
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega64
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega64
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260
;       1 /***********************************************************************
;       2 
;       3   LCD  ATmega32    :
;       4 
;       5 http://www.radiokot.ru/forum/viewtopic.php?t=5199&postdays=0&postorder=asc&start=20
;       6 
;       7 :  lexmulya  ( 17, 2007 10:11 am)     .
;       8               
;       9    (     ).
;      10   ,      .
;      11          
;      12          ,
;      13    ,    70 .
;      14 
;      15 *************************************************************************
;      16 
;      17 
;      18 AVR123.NM.RU -     CVAVR    PROTEUS 
;      19    
;      20 
;      21 LCD           ATmega32     12 
;      22 
;      23 DI    PA0
;      24 RW    PA1
;      25 E     PA2
;      26 CS1   PA3
;      27 CS2   PA4
;      28 RST   PA5
;      29 
;      30  PCx      DBx  LCD
;      31 
;      32    CVAVR 1.25.8 pro,    ,
;      33 
;      34     PROTEUS 7.2
;      35 
;      36 *******************************  2008-05-16  ******************************
;      37 
;      38   :
;      39 
;      40 http://www.roboforum.ru/viewtopic.php?f=2&t=1070
;      41 
;      42      AVR  -  www.AVR123.NM.RU
;      43 
;      44    PROTEUS  -  oProteus.narod.ru  -    !
;      45 
;      46     AVR  -  www.AVR123.NM.RU/06.htm
;      47 
;      48 *************************************************************************/
;      49 
;      50 
;      51 #include <mega64.h>
;      52 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      53 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      54 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      55 	.EQU __sm_mask=0x1C
	.EQU __sm_mask=0x1C
;      56 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      57 	.EQU __sm_powersave=0x18
	.EQU __sm_powersave=0x18
;      58 	.EQU __sm_standby=0x14
	.EQU __sm_standby=0x14
;      59 	.EQU __sm_ext_standby=0x1C
	.EQU __sm_ext_standby=0x1C
;      60 	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_adc_noise_red=0x08
;      61 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      62 	#endif
	#endif
;      63 
;      64 #include <stdio.h>
;      65 #include <delay.h>
;      66 
;      67 
;      68 //========================================================================================================
;      69 #include <macros.h>
;      70 #include <sym.h>

	.CSEG
;      71 #include <config.h>
;      72 #include <driver.h>
;      73 #include <driver.c>
;      74 /*   .     */
;      75 byte ReadCode( void ){
_ReadCode:
;      76     byte ret;
;      77     //   
;      78     LCD_DATA_PORT=0x00;
	ST   -Y,R17
;	ret -> R17
	LDI  R30,LOW(0)
	OUT  0x3,R30
;      79     LCD_DATA_DDR=0x00;
	OUT  0x2,R30
;      80     //      
;      81     ClrBit(LCD_CONTROL_PORT, A0);
	CBI  0x1B,0
;      82     SetBit(LCD_CONTROL_PORT, RDWR);
	SBI  0x1B,1
;      83     //      
;      84     delay_us(2);
	CALL SUBOPT_0x0
;      85     SetBit(LCD_CONTROL_PORT, E);
;      86     //      
;      87     delay_us(2);
	__DELAY_USB 11
;      88     ret=LCD_DATA_PIN;
	IN   R17,1
;      89     //     
;      90     ClrBit(LCD_CONTROL_PORT,E);
	CBI  0x1B,2
;      91     return ret;
	MOV  R30,R17
	RJMP _0x118
;      92 }
;      93 
;      94 
;      95 /*    */
;      96 void WaitBusy(void){
_WaitBusy:
;      97     byte stat;
;      98     //      BUSY
;      99     stat=ReadCode();
	ST   -Y,R17
;	stat -> R17
	CALL _ReadCode
	MOV  R17,R30
;     100     while(stat==(1<<BUSY)) stat=ReadCode();
_0x3:
	CPI  R17,128
	BRNE _0x5
	CALL _ReadCode
	MOV  R17,R30
;     101 }
	RJMP _0x3
_0x5:
_0x118:
	LD   R17,Y+
	RET
;     102 
;     103 
;     104 //    RESET
;     105 void WaitReset(void){
;     106     byte stat;
;     107     stat=ReadCode();
;	stat -> R17
;     108     while(stat==(1<<RESET)) stat=ReadCode();
;     109 }
;     110 
;     111 
;     112 //    ON/OFF
;     113 void WaitON(void){
;     114     byte stat;
;     115     stat=ReadCode();
;	stat -> R17
;     116     while(stat==(1<<ONOFF)) stat=ReadCode();
;     117 }
;     118 
;     119 
;     120 /*     */
;     121 byte ReadData( void ){
;     122     byte ret;
;     123     //   
;     124     WaitBusy();
;	ret -> R17
;     125     // 
;     126     LCD_DATA_PORT=0x00;
;     127     LCD_DATA_DDR=0x00;
;     128     //  
;     129     SetBit(LCD_CONTROL_PORT, A0);
;     130     SetBit(LCD_CONTROL_PORT, RDWR);
;     131     //      
;     132     delay_us(2);
;     133     SetBit(LCD_CONTROL_PORT, E);
;     134     //     
;     135     delay_us(2);
;     136     ret=LCD_DATA_PIN;
;     137     //  
;     138     ClrBit(LCD_CONTROL_PORT,E);
;     139     // 
;     140     return ret;
;     141  }
;     142 
;     143 
;     144 /*    
;     145       */
;     146 void WriteData(byte data){
_WriteData:
;     147     WaitBusy();
;	data -> Y+0
	CALL _WaitBusy
;     148     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     149 
;     150     SetBit(LCD_CONTROL_PORT, A0);
	SBI  0x1B,0
;     151     ClrBit(LCD_CONTROL_PORT, RDWR);
	CBI  0x1B,1
;     152 
;     153     delay_us(2);
	CALL SUBOPT_0x0
;     154     SetBit(LCD_CONTROL_PORT, E);
;     155     LCD_DATA_PORT=data;
	CALL SUBOPT_0x1
;     156 
;     157     delay_us(2);
;     158     ClrBit(LCD_CONTROL_PORT, E);
;     159 }
	RJMP _0x117
;     160 
;     161 
;     162 /*    */
;     163 void WriteCode(byte code){
_WriteCode:
;     164     WaitBusy();
;	code -> Y+0
	CALL _WaitBusy
;     165     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     166 
;     167     ClrBit(LCD_CONTROL_PORT, A0);
	CBI  0x1B,0
;     168     ClrBit(LCD_CONTROL_PORT, RDWR);
	CBI  0x1B,1
;     169 
;     170     delay_us(2);
	CALL SUBOPT_0x0
;     171     SetBit(LCD_CONTROL_PORT, E);
;     172     LCD_DATA_PORT=code;
	CALL SUBOPT_0x1
;     173 
;     174     delay_us(2);
;     175     ClrBit(LCD_CONTROL_PORT, E);
;     176 }
_0x117:
	ADIW R28,1
	RET
;     177 
;     178 
;     179 /*  */
;     180 void LCD_INIT( void ){
_LCD_INIT:
;     181     //  Jtag
;     182     MCUCSR = 0x80;
	LDI  R30,LOW(128)
	OUT  0x34,R30
;     183     MCUCSR = 0x80;
	OUT  0x34,R30
;     184     // 
;     185     LCD_DATA_DDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     186     LCD_CONTROL_DDR=0xFF;
	OUT  0x1A,R30
;     187     //     0.     RES
;     188     LCD_CONTROL_PORT=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     189     //    
;     190     delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     191     //  .( RES )
;     192     SetBit(LCD_CONTROL_PORT, RES);
	SBI  0x1B,5
;     193     // 1 
;     194     SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x1B,3
;     195     //     
;     196     LCD_ON;
	CALL SUBOPT_0x2
;     197     LCD_START_LINE(0);
;     198 
;     199     ClrBit(LCD_CONTROL_PORT, E1);
	CBI  0x1B,3
;     200     //   2- 
;     201     SetBit(LCD_CONTROL_PORT, E2);
	SBI  0x1B,4
;     202     WaitBusy();
	CALL _WaitBusy
;     203     LCD_ON;
	CALL SUBOPT_0x2
;     204     LCD_START_LINE(0);
;     205 }
	RET
;     206 
;     207 //  
;     208 void LCD_CLS(void){
_LCD_CLS:
;     209     byte i;
;     210     byte j;
;     211 
;     212     ClrBit(LCD_CONTROL_PORT, E2);
	ST   -Y,R17
	ST   -Y,R16
;	i -> R17
;	j -> R16
	CBI  0x1B,4
;     213     delay_us(2);
	__DELAY_USB 11
;     214     SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x1B,3
;     215     LCD_OFF;
	CALL SUBOPT_0x3
;     216     LCD_SET_ADDRESS(0);
;     217     for(i=0;i<8; i++){
_0xD:
	CPI  R17,8
	BRSH _0xE
;     218         LCD_SET_PAGE(i);
	CALL SUBOPT_0x4
;     219         for(j=0; j<64; j++){
_0x10:
	CPI  R16,64
	BRSH _0x11
;     220             WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteData
;     221         }
	SUBI R16,-1
	RJMP _0x10
_0x11:
;     222     }
	SUBI R17,-1
	RJMP _0xD
_0xE:
;     223 
;     224     LCD_ON;
	LDI  R30,LOW(63)
	ST   -Y,R30
	CALL _WriteCode
;     225     ClrBit(LCD_CONTROL_PORT, E1);
	CBI  0x1B,3
;     226     delay_us(2);
	__DELAY_USB 11
;     227     SetBit(LCD_CONTROL_PORT, E2);
	SBI  0x1B,4
;     228     LCD_OFF;
	CALL SUBOPT_0x3
;     229     LCD_SET_ADDRESS(0);
;     230     for(i=0;i<8; i++){
_0x13:
	CPI  R17,8
	BRSH _0x14
;     231         LCD_SET_PAGE(i);
	CALL SUBOPT_0x4
;     232         for(j=0; j<64; j++){
_0x16:
	CPI  R16,64
	BRSH _0x17
;     233             WriteData(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _WriteData
;     234         }
	SUBI R16,-1
	RJMP _0x16
_0x17:
;     235     }
	SUBI R17,-1
	RJMP _0x13
_0x14:
;     236     LCD_ON;
	LDI  R30,LOW(63)
	ST   -Y,R30
	CALL _WriteCode
;     237 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;     238 #include <text.c>
;     239 /*    */
;     240 void LCD_PUT_BYTE(byte x, byte y, byte data){
_LCD_PUT_BYTE:
;     241     //  
;     242     byte page;
;     243     byte bite;
;     244     //     
;     245     if((x>MAX_X)|(y>MAX_Y)) return;
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+4
;	y -> Y+3
;	data -> Y+2
;	page -> R17
;	bite -> R16
	LDD  R26,Y+4
	LDI  R30,LOW(127)
	CALL __GTB12U
	MOV  R0,R30
	LDD  R26,Y+3
	LDI  R30,LOW(63)
	CALL __GTB12U
	OR   R30,R0
	BREQ _0x18
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x116
;     246     //   63   
;     247     if(x>=64){
_0x18:
	LDD  R26,Y+4
	CPI  R26,LOW(0x40)
	BRLO _0x19
;     248         ClrBit(LCD_CONTROL_PORT, E1);
	CBI  0x1B,3
;     249         SetBit(LCD_CONTROL_PORT, E2);
	SBI  0x1B,4
;     250         x=x-64;
	LDD  R30,Y+4
	SUBI R30,LOW(64)
	STD  Y+4,R30
;     251         }
;     252         else{
	RJMP _0x1A
_0x19:
;     253         ClrBit(LCD_CONTROL_PORT, E2);
	CBI  0x1B,4
;     254         SetBit(LCD_CONTROL_PORT, E1);
	SBI  0x1B,3
;     255         }
_0x1A:
;     256     //      
;     257     page=y/8;
	LDD  R30,Y+3
	LSR  R30
	LSR  R30
	LSR  R30
	MOV  R17,R30
;     258     bite=y%8;
	LDD  R30,Y+3
	ANDI R30,LOW(0x7)
	MOV  R16,R30
;     259     //   (     )
;     260     //LCD_SET_PAGE(page);
;     261     //LCD_SET_ADDRESS(x);
;     262     // , 2 , ..     
;     263     //tmp_data=ReadData();
;     264     //tmp_data=ReadData();
;     265     //  
;     266     LCD_SET_PAGE(page);
	MOV  R30,R17
	CALL SUBOPT_0x5
;     267     LCD_SET_ADDRESS(x);
;     268     //        
;     269     switch(met){
;     270     //    case MET_OR : {WriteData(tmp_data|(data<<bite)); break;}
;     271     //    case MET_XOR : {WriteData(tmp_data^(data<<bite)); break;}
;     272     //    case MET_NOT_OR : {WriteData(tmp_data| ((data^0xFF)<<bite)); break;}
;     273     //    case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)<<bite)); break;}
;     274         case MET_OR : {WriteData(data<<bite); break;}
	BRNE _0x1E
	MOV  R30,R16
	LDD  R26,Y+2
	RJMP _0x119
;     275         case MET_XOR : {WriteData(data<<bite); break;}
_0x1E:
	CPI  R30,LOW(0x1)
	BRNE _0x1F
	MOV  R30,R16
	LDD  R26,Y+2
	RJMP _0x119
;     276         case MET_NOT_OR : {WriteData((data^0xFF)<<bite); break;}
_0x1F:
	CPI  R30,LOW(0x2)
	BREQ _0x11A
;     277         case MET_NOT_XOR : {WriteData((data^0xFF)<<bite); break;}
	CPI  R30,LOW(0x3)
	BRNE _0x1D
_0x11A:
	LDD  R26,Y+2
	LDI  R30,LOW(255)
	EOR  R26,R30
	MOV  R30,R16
_0x119:
	CALL __LSLB12
	ST   -Y,R30
	CALL _WriteData
;     278         }
_0x1D:
;     279     //          
;     280     if(bite>0){
	CPI  R16,1
	BRLO _0x22
;     281         LCD_SET_PAGE(page+1);
	MOV  R30,R17
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x5
;     282         LCD_SET_ADDRESS(x);
;     283 
;     284     //    tmp_data=ReadData();
;     285     //    tmp_data=ReadData();
;     286 
;     287     //    LCD_SET_PAGE(page+1);
;     288     //    LCD_SET_ADDRESS(x);
;     289 
;     290         switch(met){
;     291      //       case MET_OR : {WriteData(tmp_data|(data>>(8-bite))); break;}
;     292      //       case MET_XOR : {WriteData(tmp_data^(data>>(8-bite))); break;}
;     293      //       case MET_NOT_OR : {WriteData(tmp_data|((data^0xFF)>>(8-bite))); break;}
;     294      //       case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)>>(8-bite))); break;}
;     295             case MET_OR : {WriteData(data>>(8-bite)); break;}
	BRNE _0x26
	LDI  R30,LOW(8)
	SUB  R30,R16
	LDD  R26,Y+2
	RJMP _0x11B
;     296             case MET_XOR : {WriteData(data>>(8-bite)); break;}
_0x26:
	CPI  R30,LOW(0x1)
	BRNE _0x27
	LDI  R30,LOW(8)
	SUB  R30,R16
	LDD  R26,Y+2
	RJMP _0x11B
;     297             case MET_NOT_OR : {WriteData((data^0xFF)>>(8-bite)); break;}
_0x27:
	CPI  R30,LOW(0x2)
	BREQ _0x11C
;     298             case MET_NOT_XOR : {WriteData((data^0xFF)>>(8-bite)); break;}
	CPI  R30,LOW(0x3)
	BRNE _0x25
_0x11C:
	LDD  R26,Y+2
	LDI  R30,LOW(255)
	EOR  R26,R30
	LDI  R30,LOW(8)
	SUB  R30,R16
_0x11B:
	CALL __LSRB12
	ST   -Y,R30
	CALL _WriteData
;     299         }
_0x25:
;     300     }
;     301 }
_0x22:
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x116
;     302 /*  .     8*5 . */
;     303 void LCD_PUTC(byte x, byte y, byte ch){
_LCD_PUTC:
;     304     byte textL;
;     305     byte i;
;     306     //      ,  
;     307     //   
;     308     if(ch<0x90) textL=0x20;
	ST   -Y,R17
	ST   -Y,R16
;	x -> Y+4
;	y -> Y+3
;	ch -> Y+2
;	textL -> R17
;	i -> R16
	LDD  R26,Y+2
	CPI  R26,LOW(0x90)
	BRSH _0x2A
	LDI  R17,LOW(32)
;     309     else textL=0x60;
	RJMP _0x2B
_0x2A:
	LDI  R17,LOW(96)
;     310 
;     311     for(i=0; i<5; i++){
_0x2B:
	LDI  R16,LOW(0)
_0x2D:
	CPI  R16,5
	BRSH _0x2E
;     312         LCD_PUT_BYTE(x+i, y, sym[ch-textL][i]);
	CALL SUBOPT_0x6
	LDD  R30,Y+4
	SUB  R30,R17
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_sym*2)
	SBCI R31,HIGH(-_sym*2)
	MOVW R26,R30
	MOV  R30,R16
	CALL SUBOPT_0x7
	ST   -Y,R30
	CALL _LCD_PUT_BYTE
;     313         }
	SUBI R16,-1
	RJMP _0x2D
_0x2E:
;     314     //  
;     315     LCD_PUT_BYTE(x+i, y, 0x00);
	CALL SUBOPT_0x6
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LCD_PUT_BYTE
;     316 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x116
;     317 /*     */
;     318 void LCD_PUTSF(byte x, byte y, flash unsigned char str[]){
_LCD_PUTSF:
;     319     byte i=0;
;     320     //     
;     321     while(str[i]){
	ST   -Y,R17
;	x -> Y+4
;	y -> Y+3
;	*str -> Y+1
;	i -> R17
	LDI  R17,0
_0x2F:
	MOV  R30,R17
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x7
	CPI  R30,0
	BREQ _0x31
;     322         LCD_PUTC(x+i*5+i, y, str[i]);
	MOV  R26,R17
	LDI  R30,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	LDD  R26,Y+4
	ADD  R30,R26
	ADD  R30,R17
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	MOV  R30,R17
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	CALL SUBOPT_0x7
	ST   -Y,R30
	CALL _LCD_PUTC
;     323         i++;
	SUBI R17,-1
;     324     }
	RJMP _0x2F
_0x31:
;     325 }
	LDD  R17,Y+0
_0x116:
	ADIW R28,5
	RET
;     326 //========================================================================================================
;     327 
;     328 
;     329 int sec;
;     330 
;     331 
;     332 //_________________________________0__1__2__3__4__5__6__7__8__9__
;     333 flash unsigned char chislo[10] = {48,49,50,51,52,53,54,55,56,57};
;     334 
;     335 flash unsigned char *month[12] =

	.DSEG
_month:
;     336 {
;     337 ".",
;     338 ".",
;     339 ".",
;     340 ".",
;     341 ".",
;     342 ".",
;     343 ".",
;     344 ".",
;     345 ".",
;     346 ".",
;     347 ".",
;     348 "."
;     349 };
	.BYTE 0x18
;     350 
;     351 flash unsigned char *week[7] =
_week:
;     352 {
;     353 ".",
;     354 ".",
;     355 ".",
;     356 ".",
;     357 ".",
;     358 ".",
;     359 "."
;     360 };
	.BYTE 0xE
;     361 
;     362 char dat[10];
_dat:
	.BYTE 0xA
;     363 //dat[0] - ten hours
;     364 //dat[1] - one hours
;     365 //dat[2] - ten minutes
;     366 //dat[3] - one minutes
;     367 //dat[4] - week
;     368 //dat[5] - ten day
;     369 //dat[6] - one day
;     370 //dat[7] - month
;     371 //dat[8] - ten year
;     372 //dat[9] - one year
;     373 
;     374 
;     375 
;     376 
;     377 void set_month(byte a, byte b, char c, char d)
;     378 {

	.CSEG
_set_month:
;     379 
;     380         if ((a == c) && (b == d))
;	a -> Y+3
;	b -> Y+2
;	c -> Y+1
;	d -> Y+0
	LDD  R30,Y+1
	LDD  R26,Y+3
	CP   R30,R26
	BRNE _0x35
	LD   R30,Y
	LDD  R26,Y+2
	CP   R30,R26
	BREQ _0x36
_0x35:
	RJMP _0x34
_0x36:
;     381         {
;     382            dat[5] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,5
;     383            dat[6] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,6
;     384 
;     385            dat[7] = dat[7] + 1; // 
	__GETB1MN _dat,7
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,7
;     386         }
;     387 
;     388 
;     389 
;     390 
;     391 }
_0x34:
	ADIW R28,4
	RET
;     392 
;     393 
;     394 /*
;     395 ==============================================================================================
;     396 	   Timer 0
;     397 ==============================================================================================
;     398 */
;     399 
;     400 
;     401 interrupt [TIM0_OVF] void timer0_ovf_isr (void)
;     402 {
_timer0_ovf_isr:
	CALL SUBOPT_0x8
;     403 
;     404 
;     405         TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
;     406 
;     407         // 
;     408         ClrBit(PORTG,0);
	LDS  R30,101
	ANDI R30,0xFE
	STS  101,R30
;     409         delay_us(1);
	__DELAY_USB 5
;     410 
;     411         if (PINC.1 == 0)   LCD_PUTSF(0,30,"Enter");
	SBIC 0x13,1
	RJMP _0x37
	CALL SUBOPT_0x9
	__POINTW1FN _0,88
	CALL SUBOPT_0xA
;     412         if (PINC.2 == 0)   LCD_PUTSF(0,30,"Left ");
_0x37:
	SBIC 0x13,2
	RJMP _0x38
	CALL SUBOPT_0x9
	__POINTW1FN _0,94
	CALL SUBOPT_0xA
;     413         if (PINC.3 == 0)   LCD_PUTSF(0,30,"0    ");
_0x38:
	SBIC 0x13,3
	RJMP _0x39
	CALL SUBOPT_0x9
	__POINTW1FN _0,100
	CALL SUBOPT_0xA
;     414         if (PINC.4 == 0)   LCD_PUTSF(0,30,"7    ");
_0x39:
	SBIC 0x13,4
	RJMP _0x3A
	CALL SUBOPT_0x9
	__POINTW1FN _0,106
	CALL SUBOPT_0xA
;     415         if (PINC.5 == 0)   LCD_PUTSF(0,30,"4    ");
_0x3A:
	SBIC 0x13,5
	RJMP _0x3B
	CALL SUBOPT_0x9
	__POINTW1FN _0,112
	CALL SUBOPT_0xA
;     416         if (PINC.6 == 0)   LCD_PUTSF(0,30,"1    ");
_0x3B:
	SBIC 0x13,6
	RJMP _0x3C
	CALL SUBOPT_0x9
	__POINTW1FN _0,118
	CALL SUBOPT_0xA
;     417 
;     418         SetBit(PORTG,0);
_0x3C:
	LDS  R30,101
	ORI  R30,1
	STS  101,R30
;     419 
;     420 
;     421         ClrBit(PORTG,2);
	LDS  R30,101
	ANDI R30,0xFB
	STS  101,R30
;     422         delay_us(1);
	__DELAY_USB 5
;     423 
;     424         if (PINC.1 == 0)   LCD_PUTSF(0,30,"Up   ");
	SBIC 0x13,1
	RJMP _0x3D
	CALL SUBOPT_0x9
	__POINTW1FN _0,124
	CALL SUBOPT_0xA
;     425         if (PINC.2 == 0)   LCD_PUTSF(0,30,"Menu ");
_0x3D:
	SBIC 0x13,2
	RJMP _0x3E
	CALL SUBOPT_0x9
	__POINTW1FN _0,130
	CALL SUBOPT_0xA
;     426         if (PINC.3 == 0)   LCD_PUTSF(0,30,"Down ");
_0x3E:
	SBIC 0x13,3
	RJMP _0x3F
	CALL SUBOPT_0x9
	__POINTW1FN _0,136
	CALL SUBOPT_0xA
;     427         if (PINC.4 == 0)   LCD_PUTSF(0,30,"8    ");
_0x3F:
	SBIC 0x13,4
	RJMP _0x40
	CALL SUBOPT_0x9
	__POINTW1FN _0,142
	CALL SUBOPT_0xA
;     428         if (PINC.5 == 0)   LCD_PUTSF(0,30,"5    ");
_0x40:
	SBIC 0x13,5
	RJMP _0x41
	CALL SUBOPT_0x9
	__POINTW1FN _0,148
	CALL SUBOPT_0xA
;     429         if (PINC.6 == 0)   LCD_PUTSF(0,30,"2    ");
_0x41:
	SBIC 0x13,6
	RJMP _0x42
	CALL SUBOPT_0x9
	__POINTW1FN _0,154
	CALL SUBOPT_0xA
;     430 
;     431         SetBit(PORTG,2);
_0x42:
	LDS  R30,101
	ORI  R30,4
	STS  101,R30
;     432 
;     433         ClrBit(PORTC,0);
	CBI  0x15,0
;     434         delay_us(1);
	__DELAY_USB 5
;     435 
;     436         if (PINC.1 == 0)   LCD_PUTSF(0,30,"Cancl");
	SBIC 0x13,1
	RJMP _0x43
	CALL SUBOPT_0x9
	__POINTW1FN _0,160
	CALL SUBOPT_0xA
;     437         if (PINC.2 == 0)   LCD_PUTSF(0,30,"Right");
_0x43:
	SBIC 0x13,2
	RJMP _0x44
	CALL SUBOPT_0x9
	__POINTW1FN _0,166
	CALL SUBOPT_0xA
;     438         if (PINC.3 == 0)   LCD_PUTSF(0,30,"name ");
_0x44:
	SBIC 0x13,3
	RJMP _0x45
	CALL SUBOPT_0x9
	__POINTW1FN _0,172
	CALL SUBOPT_0xA
;     439         if (PINC.4 == 0)   LCD_PUTSF(0,30,"9    ");
_0x45:
	SBIC 0x13,4
	RJMP _0x46
	CALL SUBOPT_0x9
	__POINTW1FN _0,178
	CALL SUBOPT_0xA
;     440         if (PINC.5 == 0)   LCD_PUTSF(0,30,"6    ");
_0x46:
	SBIC 0x13,5
	RJMP _0x47
	CALL SUBOPT_0x9
	__POINTW1FN _0,184
	CALL SUBOPT_0xA
;     441         if (PINC.6 == 0)   LCD_PUTSF(0,30,"3    ");
_0x47:
	SBIC 0x13,6
	RJMP _0x48
	CALL SUBOPT_0x9
	__POINTW1FN _0,190
	CALL SUBOPT_0xA
;     442 
;     443         SetBit(PORTC,0);
_0x48:
	SBI  0x15,0
;     444 
;     445 
;     446 
;     447 
;     448 
;     449 
;     450 }
	RJMP _0x11D
;     451 
;     452 
;     453 
;     454 
;     455 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     456 {
_timer1_ovf_isr:
	CALL SUBOPT_0x8
;     457 
;     458 
;     459         TCNT1H=0xE1;
	LDI  R30,LOW(225)
	OUT  0x2D,R30
;     460         TCNT1L=0x7C;
	LDI  R30,LOW(124)
	OUT  0x2C,R30
;     461 
;     462         sec++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     463         if (sec >= 60)
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R6,R30
	CPC  R7,R31
	BRGE PC+3
	JMP _0x49
;     464         {
;     465         sec = 0;
	CLR  R6
	CLR  R7
;     466 
;     467            dat[3] = dat[3]+1;
	__GETB1MN _dat,3
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,3
;     468            if (dat[3] >= 10)
	__GETB2MN _dat,3
	CPI  R26,LOW(0xA)
	BRSH PC+3
	JMP _0x4A
;     469            {
;     470                 dat[3] = 0; //  10  -> 0
	LDI  R30,LOW(0)
	__PUTB1MN _dat,3
;     471                 dat[2] = dat[2] + 1;
	__GETB1MN _dat,2
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,2
;     472 
;     473                 if (dat[2] >= 6)
	__GETB2MN _dat,2
	CPI  R26,LOW(0x6)
	BRSH PC+3
	JMP _0x4B
;     474                 {
;     475                    dat[2] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,2
;     476                    dat[1] = dat[1] + 1;
	__GETB1MN _dat,1
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,1
;     477 
;     478                    if (dat[1] >= 10)
	__GETB2MN _dat,1
	CPI  R26,LOW(0xA)
	BRLO _0x4C
;     479                    {
;     480                      dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
;     481                      dat[0] = dat[0] + 1;
	LDS  R30,_dat
	SUBI R30,-LOW(1)
	STS  _dat,R30
;     482                    }
;     483 
;     484                    if (dat[0] >= 2)
_0x4C:
	LDS  R26,_dat
	CPI  R26,LOW(0x2)
	BRSH PC+3
	JMP _0x4D
;     485                    {
;     486 
;     487                      if (dat[1] >= 4)
	__GETB2MN _dat,1
	CPI  R26,LOW(0x4)
	BRSH PC+3
	JMP _0x4E
;     488                      //    (24 )
;     489                      {
;     490                          dat[1] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,1
;     491                          dat[0] = 0;
	STS  _dat,R30
;     492                          dat[4] = dat[4] + 1;
	__GETB1MN _dat,4
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,4
;     493 
;     494                          if (dat[4] >= 7)  // 
	__GETB2MN _dat,4
	CPI  R26,LOW(0x7)
	BRLO _0x4F
;     495                          {
;     496                             dat[4] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,4
;     497                          }
;     498 
;     499                          dat[6] = dat[6] + 1;
_0x4F:
	__GETB1MN _dat,6
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,6
;     500                          if (dat[6] >= 10)
	__GETB2MN _dat,6
	CPI  R26,LOW(0xA)
	BRLO _0x50
;     501                          //  10 
;     502                          {
;     503                             dat[6] = 0;           //  
	LDI  R30,LOW(0)
	__PUTB1MN _dat,6
;     504                             dat[5] = dat[5] + 1;  //  
	__GETB1MN _dat,5
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,5
;     505                          }
;     506 
;     507                          //   
;     508                          set_month(3,1,dat[5],dat[6]); //  
_0x50:
	CALL SUBOPT_0xB
;     509                          set_month(2,8,dat[5],dat[6]); //  
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0xC
;     510                          set_month(3,1,dat[5],dat[6]); //  
;     511                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0xD
;     512                          set_month(3,1,dat[5],dat[6]); //  
;     513                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0xD
;     514                          set_month(3,1,dat[5],dat[6]); //  
;     515                          set_month(3,1,dat[5],dat[6]); //  
	CALL SUBOPT_0xB
;     516                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0xD
;     517                          set_month(3,1,dat[5],dat[6]); //  
;     518                          set_month(3,0,dat[5],dat[6]); //  
	CALL SUBOPT_0xD
;     519                          set_month(3,1,dat[5],dat[6]); //  
;     520 
;     521 
;     522                          if (dat[7] >= 12)  // 12 
	__GETB2MN _dat,7
	CPI  R26,LOW(0xC)
	BRLO _0x51
;     523                          {
;     524                              dat[7] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,7
;     525 
;     526                              dat[9] = dat[9] + 1;
	__GETB1MN _dat,9
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,9
;     527                              if (dat[9] >= 10)
	__GETB2MN _dat,9
	CPI  R26,LOW(0xA)
	BRLO _0x52
;     528                              {
;     529                                 dat[9] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
;     530                                 dat[8] = dat[8] + 1;
	__GETB1MN _dat,8
	SUBI R30,-LOW(1)
	__PUTB1MN _dat,8
;     531 
;     532                                 if (dat[8] == 10) dat[8] = 0;
	__GETB1MN _dat,8
	CPI  R30,LOW(0xA)
	BRNE _0x53
	LDI  R30,LOW(0)
	__PUTB1MN _dat,8
;     533 
;     534                              }
_0x53:
;     535                          }
_0x52:
;     536                      }
_0x51:
;     537                    }
_0x4E:
;     538                 }
_0x4D:
;     539            }
_0x4B:
;     540 
;     541 
;     542         met=MET_XOR;
_0x4A:
	CALL SUBOPT_0xE
;     543         LCD_PUTC(0,0,chislo[dat[0]]);
;     544 
;     545         met=MET_XOR;
;     546         LCD_PUTC(6,0,chislo[dat[1]]);
;     547 
;     548         met=MET_XOR;
;     549         LCD_PUTSF(12,0,":");
;     550 
;     551         met=MET_XOR;
	CALL SUBOPT_0xF
;     552         LCD_PUTC(18,0,chislo[dat[2]]);
;     553 
;     554         met=MET_XOR;
;     555         LCD_PUTC(24,0,chislo[dat[3]]);
;     556 
;     557         met=MET_XOR;
;     558         LCD_PUTSF(36,0,week[dat[4]]);
;     559 
;     560         met=MET_XOR;
	CALL SUBOPT_0x10
;     561         LCD_PUTC(65,0,chislo[dat[5]]);
;     562 
;     563         met=MET_XOR;
;     564         LCD_PUTC(71,0,chislo[dat[6]]);
;     565 
;     566         met=MET_XOR;
;     567         LCD_PUTSF(80,0,month[dat[7]]);
;     568 
;     569 
;     570         met=MET_XOR;
	CALL SUBOPT_0x11
;     571         LCD_PUTSF(104,0,"20");
;     572 
;     573 
;     574         met=MET_XOR;
	CALL SUBOPT_0x12
;     575         LCD_PUTC(116,0,chislo[dat[8]]);
;     576 
;     577         met=MET_XOR;
;     578         LCD_PUTC(122,0,chislo[dat[9]]);
;     579 
;     580         }
;     581 }
_0x49:
_0x11D:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     582 
;     583 
;     584 
;     585 void main(void)
;     586 {
_main:
;     587 
;     588 	//  
;     589 	// Port D
;     590 	PORTD = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     591 	DDRD = 0xFF;
	OUT  0x11,R30
;     592 
;     593 	// Port B
;     594 	PORTB=0xFF;
	OUT  0x18,R30
;     595 	DDRB = 0xFF;
	OUT  0x17,R30
;     596 
;     597 	// Port A
;     598         PORTA = 0xFF;
	OUT  0x1B,R30
;     599 	DDRA = 0xFF;
	OUT  0x1A,R30
;     600 
;     601 	// Port C
;     602         PORTC = 0b11111110;
	LDI  R30,LOW(254)
	OUT  0x15,R30
;     603 	DDRC = 0b00000001;
	LDI  R30,LOW(1)
	OUT  0x14,R30
;     604 
;     605 	// Port E
;     606         PORTE = 0xFF;
	LDI  R30,LOW(255)
	OUT  0x3,R30
;     607 	DDRE = 0xFF;
	OUT  0x2,R30
;     608 
;     609 	// Port F
;     610         PORTF = 0xFF;
	STS  98,R30
;     611 	DDRF = 0xFF;
	STS  97,R30
;     612 
;     613 
;     614 	// Port G
;     615         PORTG = 0b1111;
	LDI  R30,LOW(15)
	STS  101,R30
;     616 	DDRG = 0x1111;
	LDI  R30,LOW(4369)
	STS  100,R30
;     617 
;     618 
;     619 	//  Timer 0
;     620 	TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     621 	TCNT0=0x64;
	LDI  R30,LOW(100)
	OUT  0x32,R30
;     622 
;     623 	//  Timer 1
;     624         TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     625         TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     626         TCNT1H=0xE1;
	LDI  R30,LOW(225)
	OUT  0x2D,R30
;     627         TCNT1L=0x7C;
	LDI  R30,LOW(124)
	OUT  0x2C,R30
;     628         OCR1BL=0x00;
	LDI  R30,LOW(0)
	OUT  0x28,R30
;     629         OCR1BH=0x00;
	OUT  0x29,R30
;     630         OCR1AL=0x00;
	OUT  0x2A,R30
;     631         OCR1AH=0x00;
	OUT  0x2B,R30
;     632 
;     633 
;     634 
;     635 
;     636         // Timer(s)/Counter(s) Interrupt(s) initialization
;     637 	TIMSK=0b101;
	LDI  R30,LOW(5)
	OUT  0x37,R30
;     638 
;     639 
;     640 
;     641 
;     642 
;     643         LCD_INIT();
	CALL _LCD_INIT
;     644 
;     645         met=MET_OR;
	CLR  R5
;     646         LCD_CLS();
	CALL _LCD_CLS
;     647 
;     648         sec = 0;
	CLR  R6
	CLR  R7
;     649 
;     650         //dat[0] - ten hours
;     651         //dat[1] - one hours
;     652         //dat[2] - ten minutes
;     653         //dat[3] - one minutes
;     654         //dat[4] - week
;     655         //dat[5] - ten day
;     656         //dat[6] - one day
;     657         //dat[7] - month
;     658         //dat[8] - ten year
;     659         //dat[9] - one year
;     660           dat[0] = 0;
	LDI  R30,LOW(0)
	STS  _dat,R30
;     661           dat[1] = 0;
	__PUTB1MN _dat,1
;     662           dat[2] = 0;
	__PUTB1MN _dat,2
;     663           dat[3] = 0;
	__PUTB1MN _dat,3
;     664           dat[4] = 4;
	LDI  R30,LOW(4)
	__PUTB1MN _dat,4
;     665           dat[5] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,5
;     666           dat[6] = 9;
	LDI  R30,LOW(9)
	__PUTB1MN _dat,6
;     667           dat[7] = 1;
	LDI  R30,LOW(1)
	__PUTB1MN _dat,7
;     668           dat[8] = 1;
	__PUTB1MN _dat,8
;     669           dat[9] = 0;
	LDI  R30,LOW(0)
	__PUTB1MN _dat,9
;     670 
;     671 
;     672         met=MET_XOR;
	CALL SUBOPT_0xE
;     673         LCD_PUTC(0,0,chislo[dat[0]]);
;     674 
;     675         met=MET_XOR;
;     676         LCD_PUTC(6,0,chislo[dat[1]]);
;     677 
;     678         met=MET_XOR;
;     679         LCD_PUTSF(12,0,":");
;     680 
;     681         met=MET_XOR;
	CALL SUBOPT_0xF
;     682         LCD_PUTC(18,0,chislo[dat[2]]);
;     683 
;     684         met=MET_XOR;
;     685         LCD_PUTC(24,0,chislo[dat[3]]);
;     686 
;     687         met=MET_XOR;
;     688         LCD_PUTSF(36,0,week[dat[4]]);
;     689 
;     690         met=MET_XOR;
	CALL SUBOPT_0x10
;     691         LCD_PUTC(65,0,chislo[dat[5]]);
;     692 
;     693         met=MET_XOR;
;     694         LCD_PUTC(71,0,chislo[dat[6]]);
;     695 
;     696         met=MET_XOR;
;     697         LCD_PUTSF(80,0,month[dat[7]]);
;     698 
;     699 
;     700         met=MET_XOR;
	CALL SUBOPT_0x11
;     701         LCD_PUTSF(104,0,"20");
;     702 
;     703 
;     704         met=MET_XOR;
	CALL SUBOPT_0x12
;     705         LCD_PUTC(116,0,chislo[dat[8]]);
;     706 
;     707         met=MET_XOR;
;     708         LCD_PUTC(122,0,chislo[dat[9]]);
;     709 
;     710 
;     711 //        met=MET_XOR;
;     712 //        LCD_PUTSF(0,0,"Display ON ...");
;     713 
;     714 //        met=MET_NOT_XOR;
;     715 //        LCD_PUTSF(56,10,"radiokot");
;     716 
;     717 
;     718 
;     719 #asm
;     720         sei
        sei
;     721 #endasm
;     722 
;     723 
;     724 while (1){
_0x54:
;     725 
;     726 
;     727         };
	RJMP _0x54
;     728 }
_0x57:
	RJMP _0x57

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

	.DSEG
_p_S53:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	__DELAY_USB 11
	SBI  0x1B,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LD   R30,Y
	OUT  0x3,R30
	__DELAY_USB 11
	CBI  0x1B,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(63)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R30,LOW(192)
	ST   -Y,R30
	JMP  _WriteCode

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(62)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	MOV  R30,R17
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _WriteCode
	LDI  R16,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _WriteCode
	LDD  R30,Y+4
	ORI  R30,0x40
	ST   -Y,R30
	CALL _WriteCode
	MOV  R30,R5
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	MOV  R30,R16
	LDD  R26,Y+4
	ADD  R30,R26
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x8:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _LCD_PUTSF

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	JMP  _set_month

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	__GETB1MN _dat,5
	ST   -Y,R30
	__GETB1MN _dat,6
	ST   -Y,R30
	CALL _set_month
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(0)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	LDS  R30,_dat
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,1
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__POINTW1FN _0,196
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:50 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,2
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(24)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,3
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(36)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,4
	LDI  R26,LOW(_week)
	LDI  R27,HIGH(_week)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:50 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(65)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,5
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(71)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,6
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(80)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,7
	LDI  R26,LOW(_month)
	LDI  R27,HIGH(_month)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(104)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__POINTW1FN _0,198
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(116)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,8
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _LCD_PUTC
	LDI  R30,LOW(1)
	MOV  R5,R30
	LDI  R30,LOW(122)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	__GETB1MN _dat,9
	LDI  R31,0
	SUBI R30,LOW(-_chislo*2)
	SBCI R31,HIGH(-_chislo*2)
	LPM  R30,Z
	ST   -Y,R30
	JMP  _LCD_PUTC

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
