/***********************************************************************

  LCD  ATmega32    :

http://www.radiokot.ru/forum/viewtopic.php?t=5199&postdays=0&postorder=asc&start=20

:  lexmulya  ( 17, 2007 10:11 am)     .
              
   (     ).
  ,      .
         
         ,
   ,    70 .

*************************************************************************


AVR123.NM.RU -     CVAVR    PROTEUS 
   

LCD           ATmega32     12 

DI    PA0
RW    PA1
E     PA2
CS1   PA3
CS2   PA4
RST   PA5

 PCx      DBx  LCD

   CVAVR 1.25.8 pro,    ,

    PROTEUS 7.2

*******************************  2008-05-16  ******************************

  :

http://www.roboforum.ru/viewtopic.php?f=2&t=1070

     AVR  -  www.AVR123.NM.RU

   PROTEUS  -  oProteus.narod.ru  -    !

    AVR  -  www.AVR123.NM.RU/06.htm

*************************************************************************/


#include <mega64.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

#include <stdio.h>
#include <delay.h>


//========================================================================================================
#include <macros.h>
#include <sym.h>
#include <config.h>
#include <driver.h>
#include <driver.c>
/*   .     */
byte ReadCode( void ){
    byte ret;
    //   
    LCD_DATA_PORT=0x00;
    LCD_DATA_DDR=0x00;
    //      
    ClrBit(LCD_CONTROL_PORT, A0);
    SetBit(LCD_CONTROL_PORT, RDWR);
    //      
    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E);
    //      
    delay_us(2);
    ret=LCD_DATA_PIN;
    //     
    ClrBit(LCD_CONTROL_PORT,E);
    return ret;
}


/*    */
void WaitBusy(void){
    byte stat;
    //      BUSY
    stat=ReadCode();
    while(stat==(1<<BUSY)) stat=ReadCode();
}


//    RESET
void WaitReset(void){
    byte stat;
    stat=ReadCode();
    while(stat==(1<<RESET)) stat=ReadCode();
}


//    ON/OFF
void WaitON(void){
    byte stat;
    stat=ReadCode();
    while(stat==(1<<ONOFF)) stat=ReadCode();
}


/*     */
byte ReadData( void ){
    byte ret;
    //   
    WaitBusy();
    // 
    LCD_DATA_PORT=0x00;
    LCD_DATA_DDR=0x00;
    //  
    SetBit(LCD_CONTROL_PORT, A0);
    SetBit(LCD_CONTROL_PORT, RDWR);
    //      
    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E);
    //     
    delay_us(2);
    ret=LCD_DATA_PIN;
    //  
    ClrBit(LCD_CONTROL_PORT,E);
    // 
    return ret;
 }


/*    
      */
void WriteData(byte data){
    WaitBusy();
    LCD_DATA_DDR=0xFF;

    SetBit(LCD_CONTROL_PORT, A0);
    ClrBit(LCD_CONTROL_PORT, RDWR);

    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E);
    LCD_DATA_PORT=data;

    delay_us(2);
    ClrBit(LCD_CONTROL_PORT, E);
}


/*    */
void WriteCode(byte code){
    WaitBusy();
    LCD_DATA_DDR=0xFF;

    ClrBit(LCD_CONTROL_PORT, A0);
    ClrBit(LCD_CONTROL_PORT, RDWR);

    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E);
    LCD_DATA_PORT=code;

    delay_us(2);
    ClrBit(LCD_CONTROL_PORT, E);
}


/*  */
void LCD_INIT( void ){
    //  Jtag
    MCUCSR = 0x80;
    MCUCSR = 0x80;
    // 
    LCD_DATA_DDR=0xFF;
    LCD_CONTROL_DDR=0xFF;
    //     0.     RES
    LCD_CONTROL_PORT=0x00;
    //    
    delay_ms(100);
    //  .( RES )
    SetBit(LCD_CONTROL_PORT, RES);
    // 1 
    SetBit(LCD_CONTROL_PORT, E1);
    //     
    LCD_ON;
    LCD_START_LINE(0);

    ClrBit(LCD_CONTROL_PORT, E1);
    //   2- 
    SetBit(LCD_CONTROL_PORT, E2);
    WaitBusy();
    LCD_ON;
    LCD_START_LINE(0);
}

//  
void LCD_CLS(void){
    byte i;
    byte j;

    ClrBit(LCD_CONTROL_PORT, E2);
    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E1);
    LCD_OFF;
    LCD_SET_ADDRESS(0);
    for(i=0;i<8; i++){
        LCD_SET_PAGE(i);
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    }

    LCD_ON;
    ClrBit(LCD_CONTROL_PORT, E1);
    delay_us(2);
    SetBit(LCD_CONTROL_PORT, E2);
    LCD_OFF;
    LCD_SET_ADDRESS(0);
    for(i=0;i<8; i++){
        LCD_SET_PAGE(i);
        for(j=0; j<64; j++){
            WriteData(0x00);
        }
    }
    LCD_ON;
}
#include <text.c>
/*    */
void LCD_PUT_BYTE(byte x, byte y, byte data){
    //  
    byte page;
    byte bite;
    //     
    if((x>MAX_X)|(y>MAX_Y)) return;
    //   63   
    if(x>=64){
        ClrBit(LCD_CONTROL_PORT, E1);
        SetBit(LCD_CONTROL_PORT, E2);
        x=x-64;
        }
        else{
        ClrBit(LCD_CONTROL_PORT, E2);
        SetBit(LCD_CONTROL_PORT, E1);
        }
    //      
    page=y/8;
    bite=y%8;
    //   (     )
    //LCD_SET_PAGE(page);
    //LCD_SET_ADDRESS(x);
    // , 2 , ..     
    //tmp_data=ReadData();
    //tmp_data=ReadData();
    //  
    LCD_SET_PAGE(page);
    LCD_SET_ADDRESS(x);
    //        
    switch(met){
    //    case MET_OR : {WriteData(tmp_data|(data<<bite)); break;}
    //    case MET_XOR : {WriteData(tmp_data^(data<<bite)); break;}
    //    case MET_NOT_OR : {WriteData(tmp_data| ((data^0xFF)<<bite)); break;}
    //    case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)<<bite)); break;}
        case MET_OR : {WriteData(data<<bite); break;}
        case MET_XOR : {WriteData(data<<bite); break;}
        case MET_NOT_OR : {WriteData((data^0xFF)<<bite); break;}
        case MET_NOT_XOR : {WriteData((data^0xFF)<<bite); break;}
        }
    //          
    if(bite>0){
        LCD_SET_PAGE(page+1);
        LCD_SET_ADDRESS(x);

    //    tmp_data=ReadData();
    //    tmp_data=ReadData();

    //    LCD_SET_PAGE(page+1);
    //    LCD_SET_ADDRESS(x);

        switch(met){
     //       case MET_OR : {WriteData(tmp_data|(data>>(8-bite))); break;}
     //       case MET_XOR : {WriteData(tmp_data^(data>>(8-bite))); break;}
     //       case MET_NOT_OR : {WriteData(tmp_data|((data^0xFF)>>(8-bite))); break;}
     //       case MET_NOT_XOR : {WriteData(tmp_data^((data^0xFF)>>(8-bite))); break;}
            case MET_OR : {WriteData(data>>(8-bite)); break;}
            case MET_XOR : {WriteData(data>>(8-bite)); break;}
            case MET_NOT_OR : {WriteData((data^0xFF)>>(8-bite)); break;}
            case MET_NOT_XOR : {WriteData((data^0xFF)>>(8-bite)); break;}
        }
    }
}
/*  .     8*5 . */
void LCD_PUTC(byte x, byte y, byte ch){
    byte textL;
    byte i;
    //      ,  
    //   
    if(ch<0x90) textL=0x20;
    else textL=0x60;

    for(i=0; i<5; i++){
        LCD_PUT_BYTE(x+i, y, sym[ch-textL][i]);
        }
    //  
    LCD_PUT_BYTE(x+i, y, 0x00);
}
/*     */
void LCD_PUTSF(byte x, byte y, flash unsigned char str[]){
    byte i=0;
    //     
    while(str[i]){
        LCD_PUTC(x+i*5+i, y, str[i]);
        i++;
    }
}
//========================================================================================================


int sec;


//_________________________________0__1__2__3__4__5__6__7__8__9__
flash unsigned char chislo[10] = {48,49,50,51,52,53,54,55,56,57};

flash unsigned char *month[12] =
{
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
"."
};

flash unsigned char *week[7] =
{
".",
".",
".",
".",
".",
".",
"."
};

char dat[10];
//dat[0] - ten hours
//dat[1] - one hours
//dat[2] - ten minutes
//dat[3] - one minutes
//dat[4] - week
//dat[5] - ten day
//dat[6] - one day
//dat[7] - month
//dat[8] - ten year
//dat[9] - one year




void set_month(byte a, byte b, char c, char d)
{

        if ((a == c) && (b == d))
        {
           dat[5] = 0;
           dat[6] = 1;

           dat[7] = dat[7] + 1; // 
        }




}


/*
==============================================================================================
	   Timer 0
==============================================================================================
*/


interrupt [TIM0_OVF] void timer0_ovf_isr (void)
{


        TCNT0=0x64;

        // 
        ClrBit(PORTG,0);
        delay_us(1);

        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Enter");
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Left ");
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"0    ");
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"7    ");
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"4    ");
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"1    ");

        SetBit(PORTG,0);


        ClrBit(PORTG,2);
        delay_us(1);

        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Up   ");
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Menu ");
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"Down ");
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"8    ");
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"5    ");
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"2    ");

        SetBit(PORTG,2);

        ClrBit(PORTC,0);
        delay_us(1);

        if (PINC.1 == 0)   LCD_PUTSF(0,30,"Cancl");
        if (PINC.2 == 0)   LCD_PUTSF(0,30,"Right");
        if (PINC.3 == 0)   LCD_PUTSF(0,30,"name ");
        if (PINC.4 == 0)   LCD_PUTSF(0,30,"9    ");
        if (PINC.5 == 0)   LCD_PUTSF(0,30,"6    ");
        if (PINC.6 == 0)   LCD_PUTSF(0,30,"3    ");

        SetBit(PORTC,0);






}




interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{


        TCNT1H=0xE1;
        TCNT1L=0x7C;

        sec++;
        if (sec >= 60)
        {
        sec = 0;

           dat[3] = dat[3]+1;
           if (dat[3] >= 10)
           {
                dat[3] = 0; //  10  -> 0
                dat[2] = dat[2] + 1;

                if (dat[2] >= 6)
                {
                   dat[2] = 0;
                   dat[1] = dat[1] + 1;

                   if (dat[1] >= 10)
                   {
                     dat[1] = 0;
                     dat[0] = dat[0] + 1;
                   }

                   if (dat[0] >= 2)
                   {

                     if (dat[1] >= 4)
                     //    (24 )
                     {
                         dat[1] = 0;
                         dat[0] = 0;
                         dat[4] = dat[4] + 1;

                         if (dat[4] >= 7)  // 
                         {
                            dat[4] = 0;
                         }

                         dat[6] = dat[6] + 1;
                         if (dat[6] >= 10)
                         //  10 
                         {
                            dat[6] = 0;           //  
                            dat[5] = dat[5] + 1;  //  
                         }

                         //   
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(2,8,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  
                         set_month(3,0,dat[5],dat[6]); //  
                         set_month(3,1,dat[5],dat[6]); //  


                         if (dat[7] >= 12)  // 12 
                         {
                             dat[7] = 0;

                             dat[9] = dat[9] + 1;
                             if (dat[9] >= 10)
                             {
                                dat[9] = 0;
                                dat[8] = dat[8] + 1;

                                if (dat[8] == 10) dat[8] = 0;

                             }
                         }
                     }
                   }
                }
           }


        met=MET_XOR;
        LCD_PUTC(0,0,chislo[dat[0]]);

        met=MET_XOR;
        LCD_PUTC(6,0,chislo[dat[1]]);

        met=MET_XOR;
        LCD_PUTSF(12,0,":");

        met=MET_XOR;
        LCD_PUTC(18,0,chislo[dat[2]]);

        met=MET_XOR;
        LCD_PUTC(24,0,chislo[dat[3]]);

        met=MET_XOR;
        LCD_PUTSF(36,0,week[dat[4]]);

        met=MET_XOR;
        LCD_PUTC(65,0,chislo[dat[5]]);

        met=MET_XOR;
        LCD_PUTC(71,0,chislo[dat[6]]);

        met=MET_XOR;
        LCD_PUTSF(80,0,month[dat[7]]);


        met=MET_XOR;
        LCD_PUTSF(104,0,"20");


        met=MET_XOR;
        LCD_PUTC(116,0,chislo[dat[8]]);

        met=MET_XOR;
        LCD_PUTC(122,0,chislo[dat[9]]);

        }
}



void main(void)
{

	//  
	// Port D
	PORTD = 0xFF;
	DDRD = 0xFF;

	// Port B
	PORTB=0xFF;
	DDRB = 0xFF;

	// Port A
        PORTA = 0xFF;
	DDRA = 0xFF;

	// Port C
        PORTC = 0b11111110;
	DDRC = 0b00000001;

	// Port E
        PORTE = 0xFF;
	DDRE = 0xFF;

	// Port F
        PORTF = 0xFF;
	DDRF = 0xFF;


	// Port G
        PORTG = 0b1111;
	DDRG = 0x1111;


	//  Timer 0
	TCCR0=0x05;
	TCNT0=0x64;

	//  Timer 1
        TCCR1B=0x05;
        TCCR1A=0x00;
        TCNT1H=0xE1;
        TCNT1L=0x7C;
        OCR1BL=0x00;
        OCR1BH=0x00;
        OCR1AL=0x00;
        OCR1AH=0x00;




        // Timer(s)/Counter(s) Interrupt(s) initialization
	TIMSK=0b101;





        LCD_INIT();

        met=MET_OR;
        LCD_CLS();

        sec = 0;

        //dat[0] - ten hours
        //dat[1] - one hours
        //dat[2] - ten minutes
        //dat[3] - one minutes
        //dat[4] - week
        //dat[5] - ten day
        //dat[6] - one day
        //dat[7] - month
        //dat[8] - ten year
        //dat[9] - one year
          dat[0] = 0;
          dat[1] = 0;
          dat[2] = 0;
          dat[3] = 0;
          dat[4] = 4;
          dat[5] = 1;
          dat[6] = 9;
          dat[7] = 1;
          dat[8] = 1;
          dat[9] = 0;


        met=MET_XOR;
        LCD_PUTC(0,0,chislo[dat[0]]);

        met=MET_XOR;
        LCD_PUTC(6,0,chislo[dat[1]]);

        met=MET_XOR;
        LCD_PUTSF(12,0,":");

        met=MET_XOR;
        LCD_PUTC(18,0,chislo[dat[2]]);

        met=MET_XOR;
        LCD_PUTC(24,0,chislo[dat[3]]);

        met=MET_XOR;
        LCD_PUTSF(36,0,week[dat[4]]);

        met=MET_XOR;
        LCD_PUTC(65,0,chislo[dat[5]]);

        met=MET_XOR;
        LCD_PUTC(71,0,chislo[dat[6]]);

        met=MET_XOR;
        LCD_PUTSF(80,0,month[dat[7]]);


        met=MET_XOR;
        LCD_PUTSF(104,0,"20");


        met=MET_XOR;
        LCD_PUTC(116,0,chislo[dat[8]]);

        met=MET_XOR;
        LCD_PUTC(122,0,chislo[dat[9]]);


//        met=MET_XOR;
//        LCD_PUTSF(0,0,"Display ON ...");

//        met=MET_NOT_XOR;
//        LCD_PUTSF(56,10,"radiokot");



#asm
        sei
#endasm


while (1){


        };
}
